//**************************************************************************//
//***                   Bull 'n' Bear Color Histo TT                       ***
//**************************************************************************//
#property copyright "  Tankk,  23  july  2016,  http://forexsystems.ru/" 
#property link      "http://forexsystemsru.com/indikatory-foreks-f41/" 
#property description "Copyright  2006, Forex-TSD.com  ==  http://www.forex-tsd.com/"
#property description "Written by IgorAD,igorad2003@yahoo.co.uk   http://finance.groups.yahoo.com/group/TrendLaboratory"
#property description " * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * "
#property description ".  Bull and Bear Power    -   EMA [13].    ''  ''     ,     ." 
#property description " "
#property description "  : 3 ."
//#property version   "1.00"

#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1 LightSteelBlue
#property indicator_color2 Crimson
#property indicator_color3 Gold   //SkyBlue

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 0
#property indicator_style3 2

#property indicator_level1 0
#property indicator_levelcolor DarkSlateGray  // SteelBlue //C'60,61,62' // 
#property indicator_levelstyle STYLE_DOT

enum hstp { HistoZero, HistoMoreLess, HistoSignal };
//**************************************************************************//
//***                 Custom indicator input parameters                    ***
//**************************************************************************//

extern int                Length  =  13;  // Period of BullAndBear
extern int                Smooth  =  1;   // Period of Smoothing MA  
extern ENUM_MA_METHOD SmoothMode  =  MODE_EMA;
extern int                Signal  =  6;   // Period of Signal MA 
extern ENUM_MA_METHOD SignalMode  =  MODE_EMA;
extern hstp            HistoType  =  HistoMoreLess;

//**************************************************************************//
//***                     Custom indicator buffers                         ***
//**************************************************************************//
double HistoUP[], HistoDN[], Sig[];
double BullnBear[], Bulls[], Bears[];
double AvgBulls[], AvgBears[], Diff[];
//**************************************************************************//
//***              Custom indicator initialization function                ***
//**************************************************************************//

int init()
{
   IndicatorBuffers(9);      IndicatorDigits(2); //MarketInfo(Symbol(),MODE_DIGITS));
   
   SetIndexBuffer(0,HistoUP);
   SetIndexBuffer(1,HistoDN);   
   SetIndexBuffer(2,Sig);
   SetIndexBuffer(3,BullnBear);
   SetIndexBuffer(4,Bulls);
   SetIndexBuffer(5,Bears);
   SetIndexBuffer(6,AvgBulls);
   SetIndexBuffer(7,AvgBears);
   SetIndexBuffer(8,Diff); 
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   
   SetIndexDrawBegin(0,3*(Length+Smooth+Signal));
   SetIndexDrawBegin(1,3*(Length+Smooth+Signal));
   SetIndexDrawBegin(2,3*(Length+Smooth+Signal));
   
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"HistoUP ["+Length+"*"+Smooth+"]");
   SetIndexLabel(1,"HistoDN ["+Length+"*"+Smooth+"]");
   SetIndexLabel(2,"Signal ["+Signal+"]");
   
   IndicatorShortName("Bull'n'Bear TT ["+Length+"*"+Smooth+","+Signal+"]");
   
//----
return(0);
}
//**************************************************************************//
//***              Custom indicator deinitialization function              ***
//**************************************************************************//
int deinit() { return (0); }
//**************************************************************************//
//***                 Custom indicator iteration function                  ***
//**************************************************************************//

int start()
{
   int i, shift, counted_bars=IndicatorCounted(), limit;
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-1; 
   if ( counted_bars < 1 ) 
   
   for(i=1;i<Length+Smooth+Signal;i++) 
     {
      BullnBear[Bars-i]=(Close[Bars-i]-Open[Bars-i])/Point;    
      Sig[Bars-i]=(Close[Bars-i]-Open[Bars-i])/Point;  
     }
//**************************************************************************//
//**************************************************************************//

   for(shift=limit;shift>=0;shift--) 
     {	
      if (Close[shift] < Open[shift])
       {
        if (Close[shift+1] < Open[shift])
        Bulls[shift] = MathMax(High[shift] - Close[shift+1], Close[shift] - Low[shift]);
        else
        Bulls[shift] = MathMax(High[shift] - Open[shift], Close[shift] - Low[shift]);
       }
      
      else if( Close[shift] > Open[shift] )
       { 
        if (Close[shift+1] > Open[shift])
        Bulls[shift] = High[shift] - Low[shift];
        else
        Bulls[shift] = MathMax(Open[shift] - Close[shift+1], High[shift] - Low[shift]);
       }
      
      else if( High[shift] - Close[shift] > Close[shift] - Low[shift] ) 
       {
        if (Close[shift+1] < Open[shift])
        Bulls[shift] = MathMax( High[shift] -  Close[shift+1],Close[shift] - Low[shift]);
        else
        Bulls[shift] = High[shift] - Open[shift];
       }
      
      else if( High[shift] - Close[shift] < Close[shift] - Low[shift])
       {
        if (Close[shift+1] > Open[shift])
        Bulls[shift] = High[shift] - Low[shift];
        else
        Bulls[shift]= MathMax(Open[shift] - Close[shift+1],High[shift] - Low[shift]);
       }
      
      else if (Close[shift+1] > Open[shift])
      Bulls[shift] = MathMax(High[shift] - Open[shift],Close[shift] - Low[shift]);
        
      else if (Close[shift+1] < Open[shift])
      Bulls[shift] = MathMax( Open[shift]- Close[shift+1], High[shift] - Low[shift]);
      
      else
      Bulls[shift] = High[shift] - Low[shift];
   
//**************************************************************************//
//***                   Bull 'n' Bear Color Histo TT                       ***
//**************************************************************************//
      
      if(Close[shift] < Open[shift])
       {
        if(Close[shift+1]>Open[shift])
        Bears[shift] = MathMax(Close[shift+1]- Open[shift],High[shift] - Low[shift]);
        else
        Bears[shift] = High[shift] - Low[shift];
       }   
      
      else if(Close[shift] > Open[shift])
       {
        if (Close[shift+1] > Open[shift])
        Bears[shift] = MathMax( Close[shift+1] - Low[shift],High[shift]- Close[shift]);
        else
        Bears[shift] = MathMax(Open[shift]- Low[shift],High[shift]- Close[shift]);
       }
      
      else if (High[shift] - Close[shift] > Close[shift] - Low[shift])
       {
        if (Close[shift+1] > Open[shift]) 
        Bears[shift] = MathMax(Close[shift+1]-Open[shift],High[shift] - Low[shift]);
        else
        Bears[shift] = High[shift] - Low[shift];
       }
      
      else if (High[shift] - Close[shift] < Close[shift] - Low[shift])
       {
        if (Close[shift+1]>Open[shift])
        Bears[shift] = MathMax(Close[shift+1]-Low[shift],High[shift]-Close[shift]);
        else
        Bears[shift] = Open[shift] - Low[shift];
       }  
      
      else if (Close[shift+1] > Open[shift])
      Bears[shift] = MathMax(Close[shift+1]-Open[shift],High[shift]-Low[shift]);
      
      else if (Close[shift+1]<Open[shift])
      Bears[shift] = MathMax(Open[shift] - Low[shift], High[shift] - Close[shift]);
      
      else
      Bears[shift] = High[shift] - Low[shift];
   }      
      
   for(shift=limit;shift>=0;shift--)
     { 
      AvgBulls[shift] = iMAOnArray(Bulls,0,Length,0,SmoothMode,shift)/Point;  
      AvgBears[shift] = iMAOnArray(Bears,0,Length,0,SmoothMode,shift)/Point;
      Diff[shift] = AvgBulls[shift] - AvgBears[shift];
     }
    
   for(shift=limit;shift>=0;shift--)
      BullnBear[shift] = iMAOnArray(Diff,0,Smooth,0,SmoothMode,shift);   
//**************************************************************************//
//***                   Bull 'n' Bear Color Histo TT                       ***
//**************************************************************************//

   for(shift=limit;shift>=0;shift--)
     {
      Sig[shift] = iMAOnArray(BullnBear,0,Signal,0,SignalMode,shift);  
      
      if (HistoType==HistoZero)
       {
        if (BullnBear[shift] > 0)   HistoUP[shift] = BullnBear[shift];   else HistoUP[shift]=EMPTY_VALUE;
        if (BullnBear[shift] < 0)   HistoDN[shift] = BullnBear[shift];   else HistoDN[shift]=EMPTY_VALUE;
       }
       
      if (HistoType==HistoMoreLess)
       {
        if (BullnBear[shift] > BullnBear[shift+1])   HistoUP[shift] = BullnBear[shift];   else HistoUP[shift]=EMPTY_VALUE;
        if (BullnBear[shift] < BullnBear[shift+1])   HistoDN[shift] = BullnBear[shift];   else HistoDN[shift]=EMPTY_VALUE;
       }
       
      if (HistoType==HistoSignal)
       {
        if (BullnBear[shift] > Sig[shift])   HistoUP[shift] = BullnBear[shift];   else HistoUP[shift]=EMPTY_VALUE;
        if (BullnBear[shift] < Sig[shift])   HistoDN[shift] = BullnBear[shift];   else HistoDN[shift]=EMPTY_VALUE;
       }
     }
     
//----
	return(0);	
}
//**************************************************************************//
//***                   Bull 'n' Bear Color Histo TT                       ***
//**************************************************************************//
